/**
 * @file  icdlext.cpp
 * @brief ICJ[hƋ g֐
 *
 * Copyright(c) 2011 sharkpp<webmaster@sharkpp.net> All rights reserved.
 * 
 * The MIT License
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * 
 * ȉɎQlƂ The MIT License ̓{𕹋L܂AЕzƂẮA
 * Lɏ]ĂB
 * 
 * The MIT License
 * 
 * ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@C
 * iȉu\tgEFAvj̕擾邷ׂĂ̐lɑ΂A\tgEFA
 * ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕gpA
 * ʁAύXAAfځAЕzATuCZXA/܂͔̔錠A
 * у\tgEFA񋟂鑊ɓƂ錠Ɋ܂܂
 * ܂B
 * 
 * L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dv
 * ȕɋLڂ̂Ƃ܂B
 * 
 * \tgEFÁû܂܁vŁAł邩Öقł邩킸A
 * ۏ؂Ȃ񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KA
 * ьNQɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂
 * ܂B҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤
 * ƁA\tgEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂
 * ̈ɂĐ؂̐AQȂ̋`ɂĉ̐ӔC
 * Ȃ̂Ƃ܂B 
 */

#include "icdlcard.h"

#if defined(ICDL_PHOTO_DECODE_ENABLE)

#include <libopenjpeg/openjpeg.h>
#ifdef _DEBUG
#pragma comment(lib,"dist/LibOpenJPEGd.lib")
#else
#pragma comment(lib,"dist/LibOpenJPEG.lib")
#endif
#endif

#if defined(ICDL_EUDC_DECODE_ENABLE)
#include <jbig2dec/jbig2.h>
#include <jbig2dec/jbig2_mmr.h>
#endif

#if defined(ICDL_PHOTO_DECODE_ENABLE)

void msg_callback(const char *msg, void * /*client_data*/)
{
#ifdef _DEBUG
	OutputDebugString(msg);
#endif
}

HBITMAP icdl_photo_to_bitmap(const unsigned char * data, size_t size)
{
	bool full_color = false;
	int w, h;
	int i;
	int adjustR, adjustG, adjustB;
	HBITMAP handle = NULL;

	opj_dparameters_t parameters = {};
	parameters.decod_format   = 1;
	parameters.cod_format     = 2;
	opj_event_mgr_t event_mgr = {};
	event_mgr.error_handler   = msg_callback;//error_callback;
	event_mgr.warning_handler = msg_callback;//warning_callback;
	event_mgr.info_handler    = msg_callback;//info_callback;
	opj_dinfo_t* dinfo = opj_create_decompress(CODEC_JP2);
	opj_set_event_mgr((opj_common_ptr)dinfo, &event_mgr, NULL);
	opj_setup_decoder(dinfo, &parameters);
	opj_cio_t *cio = opj_cio_open((opj_common_ptr)dinfo, (unsigned char*)data, size);
	opj_image_t *image = opj_decode(dinfo, cio);

	if( !image ) {
		opj_destroy_decompress(dinfo);
		opj_cio_close(cio);
		return NULL;
	}

	full_color =
		3 == image->numcomps &&
		image->comps[0].dx		== image->comps[1].dx	&&
		image->comps[1].dx		== image->comps[2].dx	&&
		image->comps[0].dy		== image->comps[1].dy	&&
		image->comps[1].dy		== image->comps[2].dy	&&
		image->comps[0].prec	== image->comps[1].prec	&&
		image->comps[1].prec	== image->comps[2].prec;

	w = image->comps[0].w;
	h = image->comps[0].h;

	BYTE               bih_mem[sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 256];
	BITMAPINFOHEADER & bih    = *(BITMAPINFOHEADER*)bih_mem;
	RGBQUAD *          pallet = (RGBQUAD*)&bih_mem[sizeof(BITMAPINFOHEADER)];

	bih.biSize			= sizeof(BITMAPINFOHEADER);
	bih.biWidth			= w;
	bih.biHeight		= h;
	bih.biPlanes		= 1;
	bih.biBitCount		= full_color ? 24 : 8;
	bih.biCompression	= 0;
	bih.biSizeImage		= full_color ? 3 * h * w + 3 * h * (w % 2)
	               		             :     h * w +     h * (w % 2);
	bih.biXPelsPerMeter	= 7834;
	bih.biYPelsPerMeter	= 7834;
	bih.biClrUsed		= full_color ? 0 : 256;
	bih.biClrImportant	= full_color ? 0 : 256;

	adjustR = 8 < image->comps[0].prec ? image->comps[0].prec - 8 : 0;
	if( full_color ) {
		adjustG = 8 < image->comps[1].prec ? image->comps[1].prec - 8 : 0;
		adjustB = 8 < image->comps[2].prec ? image->comps[2].prec - 8 : 0;
	}


	for(i = 0; i < 256; i++) {
		pallet[i].rgbRed	=
		pallet[i].rgbGreen	=
		pallet[i].rgbBlue	= (BYTE)i;
		pallet[i].rgbReserved = 0;
	}

	LPBYTE images = NULL;
	HDC hdc = GetDC(GetDesktopWindow());
	handle = CreateDIBSection(hdc, (LPBITMAPINFO)&bih, DIB_RGB_COLORS, (void**)&images, NULL, 0);
	ReleaseDC(GetDesktopWindow(), hdc);

	if( full_color )
	{
		int w_aligned = w * 3 + (3 & (~(w * 3) + 1));
		int r_add = image->comps[0].sgnd ? 1 << (image->comps[0].prec - 1) : 0;
		int g_add = image->comps[1].sgnd ? 1 << (image->comps[1].prec - 1) : 0;
		int b_add = image->comps[2].sgnd ? 1 << (image->comps[2].prec - 1) : 0;

		for(int y = 0; y < h; ++y)
		{
			RGBTRIPLE * rgb = (RGBTRIPLE*)(images + y * w_aligned);
			int index = w * h - (y + 1) * w;
			int * r_dot = &image->comps[0].data[index];
			int * g_dot = &image->comps[1].data[index];
			int * b_dot = &image->comps[2].data[index];

			for(int x = 0; x < w; ++x, ++rgb, ++r_dot, ++g_dot, ++b_dot)
			{
				int r, g, b;
				r = *r_dot + r_add; rgb->rgbtRed   = (unsigned char) ((r >> adjustR)+((r >> (adjustR-1))%2));
				g = *g_dot + g_add; rgb->rgbtGreen = (unsigned char) ((g >> adjustG)+((g >> (adjustG-1))%2));
				b = *b_dot + b_add; rgb->rgbtBlue  = (unsigned char) ((b >> adjustB)+((b >> (adjustB-1))%2));
			}
		}
	}
	else
	{
		int w_aligned = w + (3 & (~w + 1));
		int gray_add = image->comps[0].sgnd ? 1 << (image->comps[0].prec - 1) : 0;

		for(int y = 0; y < h; ++y)
		{
			LPBYTE dot = (LPBYTE)(images + y * w_aligned);
			int index = w * h - (y + 1) * w;
			int * gray_dot = &image->comps[0].data[index];

			for(int x = 0; x < w; ++x, ++dot, ++gray_dot)
			{
				int gray;

				gray = *gray_dot + gray_add;
				*dot = (unsigned char) ((gray >> adjustR)+((gray >> (adjustR-1))%2));
			}
		}
	}


	return handle;
}

#endif

#if defined(ICDL_EUDC_DECODE_ENABLE)

HBITMAP icdl_eudc_to_bitmap(const unsigned char * data, size_t size, int char_dots)
{
	Jbig2Image image;
	image.width  = char_dots;
	image.height = char_dots;
	image.stride = (char_dots + 7) >> 3;
	image.stride+= (~image.stride + 1) & 3;
	image.data   = new byte[image.stride * image.height];

	jbig2_decode_generic_mmr(NULL, NULL, NULL, data, size, &image);

	BYTE bih_mem[sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 2] = {};
	BITMAPINFOHEADER & bih = *(BITMAPINFOHEADER*)bih_mem;
	RGBQUAD * pallet = (RGBQUAD*)&bih_mem[sizeof(BITMAPINFOHEADER)];

	bih.biSize			= sizeof(bih);
	bih.biWidth			= char_dots;
	bih.biHeight		= char_dots;
	bih.biPlanes		= 1;
	bih.biBitCount		= 1;
	bih.biCompression	= 0;
	bih.biSizeImage		= image.stride * image.height;
	bih.biClrUsed		= 2;
	bih.biClrImportant	= 2;

	pallet[0].rgbRed = pallet[0].rgbGreen = pallet[0].rgbBlue = 255;

	LPBYTE images  = NULL;
	HDC     hdc    = GetDC(GetDesktopWindow());
	HBITMAP handle = CreateDIBSection(hdc, (LPBITMAPINFO)&bih, DIB_RGB_COLORS, (void**)&images, NULL, 0);
	ReleaseDC(GetDesktopWindow(), hdc);

	byte * bits = image.data + ((image.height - 1) * image.stride);
	for(int y = image.height - 1; 0 <= y; y--, bits -= image.stride, images += image.stride) {
		memcpy(images, bits, image.stride);
	}
	delete [] image.data;
	
	return handle;
}

#endif
